<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:jbg="http://jbg.sf.net/jbg"
	version="2.0">
<import href="functions/JbgBusinessFunctions.xsl" />
<output method="text" />

<template match="jbg:jbg">
	<variable name="root" select="." />
	<variable name="packages">
		<for-each select="//jbg:beans/jbg:bean/@class">
			<element name="package">
				<attribute name="name">
					<value-of select="seaf:type-package(.)" />
				</attribute>
			</element>
		</for-each>
	</variable>

<text />&lt;!DOCTYPE html
PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
&lt;html>
&lt;head>
&lt;title> JBG Beans documentation &lt;/title>
&lt;style type="text/css">
table {border-spacing:2; border-collapse:collapse;}
table, td {border:1px solid black;}
td {vertical-align:top; padding:2px 4px;}
&lt;/style>
&lt;/head>
&lt;body>
&lt;h1>
Packages
&lt;/h1>

<for-each select="distinct-values($packages//@name)">
	<variable name="package" select="." />
&lt;h2>
&lt;a name="package_<value-of select="$package"/>">
Package <value-of select="$package"/>
&lt;/a>
&lt;/h2>
&lt;table>
	&lt;tr>
		&lt;td>Bean name&lt;/td>
		&lt;td>Description&lt;/td>
	&lt;/tr>
<for-each select="$root//jbg:beans/jbg:bean[seaf:type-package(@class)=$package]">
	<variable name="bean-class" select="seaf:type-class(@class)" />
	<variable name="bean-package" select="seaf:type-package(@class)" />
	&lt;tr>
		&lt;td>&lt;a href="#bean_<value-of select="@class"/>"><text />
			<value-of select="$bean-class"/>&lt;/a>&lt;/td>
		&lt;td><value-of select="jbg:description[1]"/>&lt;/td>
	&lt;/tr>
</for-each>
&lt;/table>
</for-each>

&lt;h1>
Beans
&lt;/h1>
<for-each select="$root//jbg:beans/jbg:bean">
	<variable name="bean-type" select="@class" />
	<variable name="bean-class" select="seaf:type-class(@class)" />
	<variable name="bean-package" select="seaf:type-package(@class)" />
&lt;h2>
&lt;a name="bean_<value-of select="@class"/>">
Bean <value-of select="$bean-class"/>
&lt;/a>
&lt;/h2>
&lt;b>Bean package:&lt;/b> &lt;a href="#package_<text />
	<value-of select="$bean-package"/>"><value-of select="$bean-package"/>&lt;/a><text />
<if test="@extends">
&lt;br />
&lt;b>Extends:&lt;/b> &lt;a href="#bean_<text />
	<value-of select="@extends"/>"><value-of select="@extends"/>&lt;/a><text />
</if>
<if test="jbg:description">
&lt;br />
&lt;b>Description:&lt;/b><text />
<for-each select="jbg:description">
&lt;br />
<value-of select="."/>
</for-each>
</if>
<if test="jbg:property">
&lt;div>
&lt;b>
Properties
&lt;/b>
&lt;/div>
&lt;table>
	&lt;tr>
		&lt;td>Name&lt;/td>
		&lt;td>Type&lt;/td>
		&lt;td>Description&lt;/td>
	&lt;/tr><text />
<for-each select="jbg:property">
	&lt;tr>
		&lt;td><value-of select="@name"/>&lt;/td>
		&lt;td><value-of select="jbg:report-property-type(.)"/>&lt;/td>
		&lt;td><text />
<for-each select="jbg:description">
<if test="not(position()=1)">&lt;br /></if>
<value-of select="."/>
</for-each>
		<text />&lt;/td>
	&lt;/tr><text />
</for-each>
&lt;/table><text />
</if>
<if test="../jbg:bean[@extends=$bean-type]">
&lt;br />
&lt;b>Extended by:&lt;/b>
	<for-each select="../jbg:bean[@extends=$bean-type]">
&lt;a href="#bean_<text />
	<value-of select="@class"/>"><value-of select="@class"/>&lt;/a><text />
		<if test="not(position()=last())">, </if>
	</for-each>
</if>
</for-each>

&lt;/body>
&lt;/html>
</template>

</stylesheet>
